create or replace 
PROCEDURE XREF (SEL_OBJECT_NAME IN VARCHAR2)
AS
-- Renato Viana http://br.linkedin.com/pub/renato-menezes-viana/35/573/11b/
-- http://glufke.net/oracle/viewtopic.php?f=4&t=9662

  sid                NUMBER;
  session_user       VARCHAR2(30);
  db_name            VARCHAR2(30);
  os_user            VARCHAR2(30);
  os_terminal        VARCHAR2(30);
  ip_address         VARCHAR2(30);

  v_set number;
  v_owner varchar2(30);
  v_object_name varchar2(30);
  v_object_type varchar2(30);
  v_procedure_name varchar2(30);



CURSOR AO is --- All Objects (No Data) [[[OK]]]
select b.owner, b.object_name, b.object_id, b.object_type from all_objects b
where b.owner IN (select owner from xrf_owners)
  and b.object_name like '%'||SEL_OBJECT_NAME||'%'
  and b.object_type <> 'SYNONYM' 
  and b.object_type <> 'PACKAGE'
  and b.status = 'VALID'
  and b.data_object_id is null  
  order by b.object_name, b.owner;


CURSOR APNN is --- All Procedures Name Null [[[OK]]]
select * from all_procedures
where object_name = v_object_name
  and owner = v_owner
  and procedure_name is null;
  

CURSOR PD IS  --- Public Dependency (No Data) [[[OK]]]
select * from (
SELECT distinct B.OBJECT_ID, 
   b.owner, 
   b.object_type TYPE, 
   b.object_name NAME,  
   b.status,  
   replace(b.object_type,' ','_') type_link, 
   b.owner sdev_link_owner, 
   b.object_name sdev_link_name, 
   b.object_type sdev_link_type 
FROM 
   sys.all_objects b, 
   (SELECT object_id, referenced_object_id 
    FROM public_dependency 
    START WITH object_id = v_set
    CONNECT BY NOCYCLE PRIOR referenced_object_id = object_id) c 
WHERE b.object_id = c.referenced_object_id 
AND b.owner NOT IN ('SYS', 'SYSTEM') 
AND b.object_type <> 'SYNONYM'
AND b.object_name <> 'DUAL'
 ) sub1 order by 4,2;


CURSOR AOP is --- All Select Procedures Objects 
select * from xrf_dependencies
where status = 'VALID'
  and P_NAME is null
  and P_OBJECT_NAME <> NAME  
  and type <> 'TABLE'
  and type <> 'INDEX'
  and type <> 'SYNONYM'
  order by name, owner;


CURSOR AOD is --- All Select Data Objects 
select * from xrf_dependencies
where status = 'VALID'
  and P_NAME is null
  and (type = 'TABLE' or type = 'INDEX')
  order by name, owner;



CURSOR AD IS --- All Data Dependencies
SELECT distinct OWNER, NAME, TYPE, REFERENCED_OWNER, REFERENCED_NAME, REFERENCED_TYPE, OWNER SDEV_LINK_OWNER, NAME SDEV_LINK_NAME, TYPE SDEV_LINK_TYPE 
FROM ALL_DEPENDENCIES WHERE REFERENCED_OWNER = V_OWNER AND REFERENCED_NAME = V_OBJECT_NAME  AND TYPE <> 'SYNONYM' order by 2,1;


----- FASE II -------------- [[[OK]]] - cobrir referencia

CURSOR SAO is --- All Source Objects Procedures Names.Package (No Data)
select b.owner, b.object_name, b.object_id, b.object_type from all_objects b
where b.owner IN (select owner from xrf_owners)
  and b.object_name like '%'||SEL_OBJECT_NAME||'%'
  and b.object_type <> 'PACKAGE'
  and b.status = 'VALID'
  and b.data_object_id is null  
  order by b.object_name, b.owner;

CURSOR SPNP is --- All Source Procedures Names.Package (No Data)
select * from all_procedures
where object_name = v_object_name
  and owner = v_owner
---  and procedure_name is not null
  order by object_name, procedure_name, owner;


CURSOR SP IS --- All Source Procedures Names.Package (No Data) <--- Referenciado por
SELECT owner, name, line, type from all_source ----  v_owner, v_object_name, v_set, v_object_type;
where name <> v_object_name and type <> 'PACKAGE'
  and UPPER(TEXT) like '%'||v_procedure_name||'%';


  
BEGIN

dbms_output.put_line('Seleo Like Procedure:'||sel_object_name);

      DELETE xrf_dependencies;
      
      
      SELECT SYS_CONTEXT( 'USERENV', 'SID' ) INTO sid FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'IP_ADDRESS' ) INTO ip_address FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'TERMINAL' ) INTO os_terminal FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'OS_USER' ) INTO os_user FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'DB_NAME' ) INTO db_name FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'SESSION_USER' ) INTO session_user FROM DUAL;

    dbms_output.put_line('OS_USER:'||os_user);
    dbms_output.put_line('SESSION_USER:'||session_user);

/* ------- Teste Comprova que ALL_SOURCE no funciona 100% (idem ALL_OBJECTS)
  v_procedure_name := 'EP__RAIS_CONSIST_TOTALIZACAO1';

  open SP;
  loop
  fetch SP into v_owner, v_object_name, v_set, v_object_type;
  exit when SP%notfound;
  dbms_output.put_line(v_owner||v_object_name||v_set||v_object_type);
 
  end loop;
  close SP;
*/ 
 
commit;
    
  for a1 in AO loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.object_name;
  
  dbms_output.put_line('A1 = Owner:'||a1.owner||' Object_name:'||a1.object_name||' Object_id:'||a1.object_id);
  
  for b1 in APNN loop
  
  dbms_output.put_line('B1 = Owner:'||b1.owner||' Object_name:'||b1.object_name||' Object_id:'||b1.object_id);
  
  
  for c1 in PD loop
  
  

begin

---dbms_output.put_line('C1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.object_id);

  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.OBJECT_NAME
,b1.PROCEDURE_NAME
,a1.OBJECT_TYPE
,a1.OBJECT_ID
,c1.OWNER
,c1.NAME
,c1.TYPE
,c1.OBJECT_ID
,c1.STATUS
,c1.TYPE_LINK
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('DUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.object_id);

WHEN OTHERS THEN
dbms_output.put_line('P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||a1.object_name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
  end loop; 

commit;
-----------------------------------------------------------------
dbms_output.put_line('FASE I OK:'||sqlerrm);
-----------------------------------------------------------------

/*
  open SAO;
  loop
  fetch SAO into v_owner, v_object_name, v_set, v_object_type;
  exit when SAO%notfound;
  v_set := v_set/10**Length(to_char(v_set));
  dbms_output.put_line('SAO:'||v_owner||v_object_name||v_set||v_object_type);
 
  end loop;
  close SAO;
*/ 

  for a1 in SAO loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.object_name;
  
---  dbms_output.put_line('SA1 = Owner:'||a1.owner||' Object_name:'||a1.object_name||' Object_id:'||a1.object_id);
  
  for b1 in SPNP loop
  
  if b1.procedure_name is not null then
  v_procedure_name := UPPER(b1.procedure_name);
  else
  v_procedure_name := UPPER(b1.object_name);
  end if;
  
---  dbms_output.put_line('SB1 = Owner:'||b1.owner||' Object_name:'||b1.object_name||' Object_id:'||b1.object_id||' Procedure:'||v_procedure_name);
  
  
  for c1 in SP loop
  
  

begin

--- dbms_output.put_line('SC1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.line);
                                                                                        --------------
  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.OBJECT_NAME
,b1.PROCEDURE_NAME
,a1.OBJECT_TYPE
,a1.OBJECT_ID
,c1.OWNER
,c1.NAME
,c1.TYPE
,b1.SUBPROGRAM_ID
,'<SUBPROGRAM | P_OBJECT_NAME>'
,a1.OBJECT_NAME ------------------------
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('SDUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.line);
                                                                                               ------------
WHEN OTHERS THEN
dbms_output.put_line('SP_OWNER:'||a1.owner||' P_OBJECT_NAME:'||a1.object_name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
  end loop; 

commit;

dbms_output.put_line('FASE II OK:'||sqlerrm);


---------------------------------------------------------
--- Inicio da FASE III 
---------------------------------------------------------

  for a1 in AOP loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.name;
  
---  dbms_output.put_line('AOP = Owner:'||a1.owner||' name:'||a1.name||' Object_id:'||a1.object_id);
  
  for b1 in PD loop
  
  v_procedure_name := null;
  


begin

---- dbms_output.put_line('AOP1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.line);
                                                                                        --------------
  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.NAME
,null
,a1.TYPE
,a1.OBJECT_ID
,b1.OWNER
,b1.NAME
,b1.TYPE
,b1.OBJECT_ID
,'P_OBJECT_NAME>'
,a1.P_OBJECT_NAME ------------------------
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('AOPDUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.line);
                                                                                               ------------
WHEN OTHERS THEN
dbms_output.put_line('AOP_OWNER:'||a1.owner||' NAME:'||a1.name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
 
commit;

dbms_output.put_line('FASE III OK:'||sqlerrm);


---------------------------------------------------------
--- Inicio da FASE IV
---------------------------------------------------------

  for a1 in AOD loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.name;
  
---  dbms_output.put_line('AOD = Owner:'||a1.owner||' name:'||a1.name||' Object_id:'||a1.object_id);
  
  for b1 in AD loop
  
  v_procedure_name := null;
  


begin

---- dbms_output.put_line('AOP1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.line);
                                                                                        --------------
  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.NAME
,null
,a1.TYPE
,a1.OBJECT_ID
,b1.OWNER
,b1.NAME
,b1.TYPE
,a1.P_OBJECT_ID
,'<P_OBJECT_ID | P_OBJECT_NAME>'
,a1.P_OBJECT_NAME ------------------------
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('AOPDUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.line);
                                                                                               ------------
WHEN OTHERS THEN
dbms_output.put_line('AOP_OWNER:'||a1.owner||' NAME:'||a1.name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
 
commit;

dbms_output.put_line('FASE IV OK:'||sqlerrm);



EXCEPTION
WHEN OTHERS THEN
dbms_output.put_line('ERRO:'||sqlerrm);
END;